#!/bin/sh

# color escape sequences
RED="\\033[1;31m"
GREEN="\\033[0;32m"
WHITE="\\033[0;39m"
YELLOW="\\033[1;33m"

# other vars
IPTABLES="/sbin/iptables"
LOCALINTERFACE="eth0"
INTERFACEMASK=255.255.255.0
LOCALNET=192.168.0.0/24
LOOPBACK=127.0.0.1
LOCALIP="192.168.0.1"


######################
# start  firewall
######################
start()
{

# caricamento moduli necessari
  /sbin/insmod ip_tables > /dev/null 2> /dev/null
  /sbin/insmod iptable_NAT > /dev/null 2> /dev/null
  /sbin/insmod ip_conntrack > /dev/null 2> /dev/null
  /sbin/insmod ipt_MASQUERADE > /dev/null 2> /dev/null

# stampa info
  echo "Attivazione del Firewall in corso..."
  echo -e "Indirizzo IP locale ${YELLOW} $LOCALINTERFACE${WHITE} : ${RED}$LOCALIP${WHITE}"

# flush regole
  echo -n "Flushing delle regole eventualmente presenti : "
  $IPTABLES -F INPUT > /dev/null
  $IPTABLES -F OUTPUT > /dev/null
  $IPTABLES -F FORWARD > /dev/null
  $IPTABLES -t nat -F > /dev/null
  echo -e "\t\t\t[ ${GREEN}OK ${WHITE}]"

# attivazione ip_forward  
  echo -n "Disattivazione del Forward dei pacchetti: "
  echo 1 > /proc/sys/net/ipv4/ip_forward
  echo -e "\t\t\t[ ${GREEN}OK ${WHITE}]"

# regole filtraggio
  echo -n "Impostazioni delle regole di filtraggio : "
  iptables -P INPUT DROP
  iptables -P FORWARD DROP
  iptables -t nat -A POSTROUTING -j MASQUERADE
  iptables -A FORWARD -s 192.168.0.0/24 -j ACCEPT
  iptables -A FORWARD -d 192.168.0.0/24 -j ACCEPT
  iptables -A FORWARD -j DROP
  #iptables -A PREROUTING -t nat -d 192.168.0.1 -p tcp --dport 80 -j DNAT --to-destination 192.168.0.4:80    
  echo -e "\t\t\t[ ${GREEN}OK ${WHITE}]"

}



#################
# stop firewall
#################
stop() 
{

  echo "Disattivazione del Firewall in corso..."
  $IPTABLES -F
  $IPTABLES -P INPUT ACCEPT
  $IPTABLES -P OUTPUT ACCEPT
  $IPTABLES -P FORWARD DROP
  $IPTABLES -t nat -F

  echo -n "Rimozione dei moduli necessari : "
  /sbin/rmmod ip_conntrack > /dev/null 2> /dev/null
  /sbin/rmmod ipt_MASQUERADE > /dev/null 2> /dev/null
  /sbin/rmmod iptable_nat > /dev/null 2> /dev/null
  
  echo -e "\t\t[ ${GREEN}OK ${WHITE}]"
  echo -n "Disattivazione IP forwarding : "
  echo 0 > /proc/sys/net/ipv4/ip_forward
  echo -e "\t\t\t[ ${GREEN}OK ${WHITE}]"
  echo -e "${YELLOW}ATTENZIONE: IL FIREWALL NON E' PIU' OPERATIVO${WHITE}"
  
}


case "$1" in
  start)
        start
        ;;
  stop)
        stop
        ;;
  status)
        iptables -L -v
        ;;
  *)
        echo "Usage: $0 {start | stop | status}"
        exit 1
		;;
esac
exit 0