/*
 * misc.c
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, 
 *  USA.
 *
 */

#include "misc.h"

/*************************************
** Trim spaces and newline from str
**************************************/
char* trim(char *str)
{
	char *pch = str;
	while(isspace(*pch)) 		
		pch++;
	if(pch != str) 		
		memmove(str, pch, (strlen(pch) + 1));
	pch = (char*)(str + (strlen(str) - 1));
	while(isspace(*pch)) 
		pch--;
	*++pch = '\0';
	return str;
}



/*******************************
** Convert string to uppercase
********************************/
char* strtoupper(char *str)
{
	char *ptr = str;
	while(*ptr) 
		{
		(*ptr) = toupper(*ptr);
		ptr++;
		}
	return str;
}


/*********************************
** Get interface ip address, by 
** James Meehan <rom@casino770.com>
*********************************/
int get_interface_address (char *device, char *ipbuffer, int bufferlen)
{
    int                 err, fd ;
    struct ifreq        if_request ;
    struct sockaddr_in  *sa_in ;

    fd = socket (PF_INET, SOCK_DGRAM, 0) ;
    if (fd < 0) 
    	{
    	printf("Errore nella creazione del socket");
    	return 1;
    	}

    bzero (&if_request, sizeof(if_request)) ;
    strncpy (if_request.ifr_name, device, strlen(device)) ;
    err = ioctl (fd, SIOCGIFADDR, &if_request) ;
    if (err) 
    	return 1 ;

    sa_in = (struct sockaddr_in*)&if_request.ifr_addr ;
    strncpy (ipbuffer, inet_ntoa(sa_in->sin_addr), bufferlen) ;

    close (fd) ;

    return 0 ;
}


